# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class BatchResponse(Model):
    """BatchResponse.

    :param batch_id: The batch identifier
    :type batch_id: int
    :param batch_code: The batch code
    :type batch_code: str
    :param is_open: Is the batch open
    :type is_open: bool
    :param batch_status: The status of the batch (open, pending, closed)
    :type batch_status: str
    :param start_date: The date when the batch was created
    :type start_date: datetime
    :param end_date: The date when the batch was closed
    :type end_date: datetime
    :param bill_count: The number of bills in this batch
    :type bill_count: int
    :param running_total: The cost of  all bills in this batch
    :type running_total: float
    :param statement_date: Statement date batch setting
    :type statement_date: str
    :param due_date: Due date batch setting
    :type due_date: str
    :param next_reading: Next reading date batch setting
    :type next_reading: str
    :param control_code: Control code batch setting
    :type control_code: str
    :param invoice_number: Invoice number batch setting
    :type invoice_number: str
    :param account_period_name: Account period name batch setting
    :type account_period_name: str
    :param account_period_number: Account period number batch setting
    :type account_period_number: int
    :param account_period_year: Account period year batch setting
    :type account_period_year: int
    :param note: Note/comment for the batch
    :type note: str
    :param created_by:
    :type created_by: ~energycap.sdk.models.UserChild
    :param flag_count: Number of unresolved flags on bills contained in this
     batch
    :type flag_count: int
    :param analyzing_count: Number of bills contained in this batch that are
     currently being analyzed
    :type analyzing_count: int
    :param has_imported_bills: Denotes if the Batch has any imported bills
     associated with it
    :type has_imported_bills: bool
    """

    _attribute_map = {
        'batch_id': {'key': 'batchId', 'type': 'int'},
        'batch_code': {'key': 'batchCode', 'type': 'str'},
        'is_open': {'key': 'isOpen', 'type': 'bool'},
        'batch_status': {'key': 'batchStatus', 'type': 'str'},
        'start_date': {'key': 'startDate', 'type': 'iso-8601'},
        'end_date': {'key': 'endDate', 'type': 'iso-8601'},
        'bill_count': {'key': 'billCount', 'type': 'int'},
        'running_total': {'key': 'runningTotal', 'type': 'float'},
        'statement_date': {'key': 'statementDate', 'type': 'str'},
        'due_date': {'key': 'dueDate', 'type': 'str'},
        'next_reading': {'key': 'nextReading', 'type': 'str'},
        'control_code': {'key': 'controlCode', 'type': 'str'},
        'invoice_number': {'key': 'invoiceNumber', 'type': 'str'},
        'account_period_name': {'key': 'accountPeriodName', 'type': 'str'},
        'account_period_number': {'key': 'accountPeriodNumber', 'type': 'int'},
        'account_period_year': {'key': 'accountPeriodYear', 'type': 'int'},
        'note': {'key': 'note', 'type': 'str'},
        'created_by': {'key': 'createdBy', 'type': 'UserChild'},
        'flag_count': {'key': 'flagCount', 'type': 'int'},
        'analyzing_count': {'key': 'analyzingCount', 'type': 'int'},
        'has_imported_bills': {'key': 'hasImportedBills', 'type': 'bool'},
    }

    def __init__(self, **kwargs):
        super(BatchResponse, self).__init__(**kwargs)
        self.batch_id = kwargs.get('batch_id', None)
        self.batch_code = kwargs.get('batch_code', None)
        self.is_open = kwargs.get('is_open', None)
        self.batch_status = kwargs.get('batch_status', None)
        self.start_date = kwargs.get('start_date', None)
        self.end_date = kwargs.get('end_date', None)
        self.bill_count = kwargs.get('bill_count', None)
        self.running_total = kwargs.get('running_total', None)
        self.statement_date = kwargs.get('statement_date', None)
        self.due_date = kwargs.get('due_date', None)
        self.next_reading = kwargs.get('next_reading', None)
        self.control_code = kwargs.get('control_code', None)
        self.invoice_number = kwargs.get('invoice_number', None)
        self.account_period_name = kwargs.get('account_period_name', None)
        self.account_period_number = kwargs.get('account_period_number', None)
        self.account_period_year = kwargs.get('account_period_year', None)
        self.note = kwargs.get('note', None)
        self.created_by = kwargs.get('created_by', None)
        self.flag_count = kwargs.get('flag_count', None)
        self.analyzing_count = kwargs.get('analyzing_count', None)
        self.has_imported_bills = kwargs.get('has_imported_bills', None)
