# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class BillImportRequest(Model):
    """BillImportRequest.

    All required parameters must be populated in order to send to Azure.

    :param profile_code: optional - if not provided, we assume the data is in
     Advanced format
     A bill import profile code.
     Maps given data to Advanced format using the mappings defined by this
     profile
    :type profile_code: str
    :param file_name: Required. FileName for the import file. Should include
     extension.
     Example: fileABC.csv
     Data contains the contents. The importer will save the under this file
     name.
     The extension allows the importer to read the data in the proper format
     (csv,xlsx,zip) <span class='property-internal'>Required</span>
    :type file_name: str
    :param batch_settings:
    :type batch_settings: ~energycap.sdk.models.BatchSettings
    :param data: Required. The base64 encoded file. <span
     class='property-internal'>Required</span>
    :type data: str
    :param import_note: Optional note/comment.
    :type import_note: str
    :param save_as_resolved: Optional  property to indicate if failed audits
     automatically get marked as resolved
    :type save_as_resolved: bool
    :param comment: Optional comment to explain why the audit is being auto
     resolved
    :type comment: str
    """

    _validation = {
        'file_name': {'required': True},
        'data': {'required': True},
    }

    _attribute_map = {
        'profile_code': {'key': 'profileCode', 'type': 'str'},
        'file_name': {'key': 'fileName', 'type': 'str'},
        'batch_settings': {'key': 'batchSettings', 'type': 'BatchSettings'},
        'data': {'key': 'data', 'type': 'str'},
        'import_note': {'key': 'importNote', 'type': 'str'},
        'save_as_resolved': {'key': 'saveAsResolved', 'type': 'bool'},
        'comment': {'key': 'comment', 'type': 'str'},
    }

    def __init__(self, **kwargs):
        super(BillImportRequest, self).__init__(**kwargs)
        self.profile_code = kwargs.get('profile_code', None)
        self.file_name = kwargs.get('file_name', None)
        self.batch_settings = kwargs.get('batch_settings', None)
        self.data = kwargs.get('data', None)
        self.import_note = kwargs.get('import_note', None)
        self.save_as_resolved = kwargs.get('save_as_resolved', None)
        self.comment = kwargs.get('comment', None)
