# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class CostAvoidanceTask(Model):
    """CostAvoidanceTask.

    :param has_attachments: Indicates whether or not the task has an output
     log available for download
    :type has_attachments: bool
    :param cost_avoidance_task_id: The task ID
    :type cost_avoidance_task_id: int
    :param task_gu_id: The task GUID
    :type task_gu_id: str
    :param task_type:
    :type task_type: ~energycap.sdk.models.TaskType
    :param begin_date: The date and time the task began
    :type begin_date: datetime
    :param end_date: The date and time the task finished. If the task is not
     finished, endDate will have no value
    :type end_date: datetime
    :param user:
    :type user: ~energycap.sdk.models.UserChild
    :param settings:
    :type settings: ~energycap.sdk.models.CostAvoidanceSettings
    :param filters: The task's filters
    :type filters: list[~energycap.sdk.models.FilterResponse]
    :param message: If there was a catastrophic error during task processing,
     it will go here
    :type message: str
    :param reason: The reason for the cost avoidance task. Will be one of the
     following:
     * ResetBaseline
     * SavedAndReprocessedMeter
     * ProcessSavings
     * SpecialAdjustmentAddedEditedRemoved
     * SpecialAdjustmentAddedEditedRemovedSetupSheet
     * MeterCostAvoidanceSettingsGloballyUpdated
     * AucRangeModified
     * OtherSavingsAddedEdited
     * OtherSavingsAddedEditedSetupSheet
    :type reason: str
    :param status: The status of the cost avoidance task. Will be one of the
     following:
     * Processing
     * Complete
     * Error
    :type status: str
    :param task_note: Notes added to the cost avoidance task by the user
    :type task_note: str
    :param baseline_log:
    :type baseline_log: ~energycap.sdk.models.BaselineLog
    :param savings_log:
    :type savings_log: ~energycap.sdk.models.SavingsLog
    """

    _attribute_map = {
        'has_attachments': {'key': 'hasAttachments', 'type': 'bool'},
        'cost_avoidance_task_id': {'key': 'costAvoidanceTaskId', 'type': 'int'},
        'task_gu_id': {'key': 'taskGUId', 'type': 'str'},
        'task_type': {'key': 'taskType', 'type': 'TaskType'},
        'begin_date': {'key': 'beginDate', 'type': 'iso-8601'},
        'end_date': {'key': 'endDate', 'type': 'iso-8601'},
        'user': {'key': 'user', 'type': 'UserChild'},
        'settings': {'key': 'settings', 'type': 'CostAvoidanceSettings'},
        'filters': {'key': 'filters', 'type': '[FilterResponse]'},
        'message': {'key': 'message', 'type': 'str'},
        'reason': {'key': 'reason', 'type': 'str'},
        'status': {'key': 'status', 'type': 'str'},
        'task_note': {'key': 'taskNote', 'type': 'str'},
        'baseline_log': {'key': 'baselineLog', 'type': 'BaselineLog'},
        'savings_log': {'key': 'savingsLog', 'type': 'SavingsLog'},
    }

    def __init__(self, **kwargs):
        super(CostAvoidanceTask, self).__init__(**kwargs)
        self.has_attachments = kwargs.get('has_attachments', None)
        self.cost_avoidance_task_id = kwargs.get('cost_avoidance_task_id', None)
        self.task_gu_id = kwargs.get('task_gu_id', None)
        self.task_type = kwargs.get('task_type', None)
        self.begin_date = kwargs.get('begin_date', None)
        self.end_date = kwargs.get('end_date', None)
        self.user = kwargs.get('user', None)
        self.settings = kwargs.get('settings', None)
        self.filters = kwargs.get('filters', None)
        self.message = kwargs.get('message', None)
        self.reason = kwargs.get('reason', None)
        self.status = kwargs.get('status', None)
        self.task_note = kwargs.get('task_note', None)
        self.baseline_log = kwargs.get('baseline_log', None)
        self.savings_log = kwargs.get('savings_log', None)
