# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class ManualAdjustmentRequest(Model):
    """ManualAdjustmentRequest.

    All required parameters must be populated in order to send to Azure.

    :param batcc_native_use: The manually adjusted Baseline Adjusted to
     Current Conditions (BATCC) native use <span
     class='property-internal'>Required when locked is set to True</span>
    :type batcc_native_use: float
    :param batcc_cost: The manually adjusted Baseline Adjusted to Current
     Conditions (BATCC) cost <span class='property-internal'>Required when
     locked is set to True</span>
    :type batcc_cost: float
    :param bill_mtr_note: Required. The manual adjustment note explaining the
     reason for the adjustment <span class='property-internal'>Required</span>
    :type bill_mtr_note: str
    :param locked: Required. Indicates whether or not the values in a savings
     record are locked (this is not changed by future runs of the savings
     processor)
     Set to true when a manual adjustment is being created.
     Set to false when a manual adjustment is being removed.
     If locked is set to false, all other values are ignored and will be set by
     the savings processor. <span class='property-internal'>Required</span>
    :type locked: bool
    """

    _validation = {
        'bill_mtr_note': {'required': True},
        'locked': {'required': True},
    }

    _attribute_map = {
        'batcc_native_use': {'key': 'batccNativeUse', 'type': 'float'},
        'batcc_cost': {'key': 'batccCost', 'type': 'float'},
        'bill_mtr_note': {'key': 'billMtrNote', 'type': 'str'},
        'locked': {'key': 'locked', 'type': 'bool'},
    }

    def __init__(self, **kwargs):
        super(ManualAdjustmentRequest, self).__init__(**kwargs)
        self.batcc_native_use = kwargs.get('batcc_native_use', None)
        self.batcc_cost = kwargs.get('batcc_cost', None)
        self.bill_mtr_note = kwargs.get('bill_mtr_note', None)
        self.locked = kwargs.get('locked', None)
