# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class SystemSettingsRequest(Model):
    """SystemSettingsRequest.

    All required parameters must be populated in order to send to Azure.

    :param organization_name: The organization name <span
     class='property-internal'>Required (defined)</span>
    :type organization_name: str
    :param display_organization_name_in_header: Required. Indicates whether or
     not organization name should be displayed in the application header <span
     class='property-internal'>Required</span>
    :type display_organization_name_in_header: bool
    :param organization_logo: The organization logo
     May be a base64-encoded PNG, JPG, or SVG image or a URI for an image
     hosted online
     A null value will clear the saved image <span
     class='property-internal'>Required (defined)</span>
    :type organization_logo: str
    :param automatic_logout_minutes: Number of minutes after which users will
     be automatically logged out <span class='property-internal'>Must be
     between 10 and 780</span> <span class='property-internal'>Required
     (defined)</span>
    :type automatic_logout_minutes: int
    :param default_country: Default country for new users <span
     class='property-internal'>Required (defined)</span>
    :type default_country: str
    :param default_meter_time_zone_id: Required. ID of the default time zone
     for new meters <span class='property-internal'>Required</span>
    :type default_meter_time_zone_id: int
    :param default_date_format: Default date format for new users <span
     class='property-internal'>One of MM/dd/yyyy, dd/MM/yyyy </span> <span
     class='property-internal'>Required (defined)</span>
    :type default_date_format: str
    :param default_topmost_cost_center_id: Default topmost cost center ID for
     new users <span class='property-internal'>Required (defined)</span>
    :type default_topmost_cost_center_id: int
    :param default_topmost_place_id: Default topmost place ID for new users
     <span class='property-internal'>Required (defined)</span>
    :type default_topmost_place_id: int
    :param default_user_role_id: Default user role ID for new users <span
     class='property-internal'>Required (defined)</span>
    :type default_user_role_id: int
    :param months_to_exclude_from_charts: Months to exclude from charts,
     including the current month. Set to 2 months by default.
     Ex. If the current month is October,
     A value of 0 will not exclude any months,
     A value of 1 will exclude the month of October,
     A value of 2 will exclude October and September,
     A value of 3 will exclude October, September, and August,
     A value of 13 will exclude October and the last full year of data.
     A null value will preserve the existing setting. <span
     class='property-internal'>Must be between 0 and 13</span> <span
     class='property-internal'>Required (defined)</span>
    :type months_to_exclude_from_charts: int
    """

    _validation = {
        'display_organization_name_in_header': {'required': True},
        'organization_logo': {'min_length': 5},
        'automatic_logout_minutes': {'maximum': 780, 'minimum': 10},
        'default_meter_time_zone_id': {'required': True},
        'months_to_exclude_from_charts': {'maximum': 13, 'minimum': 0},
    }

    _attribute_map = {
        'organization_name': {'key': 'organizationName', 'type': 'str'},
        'display_organization_name_in_header': {'key': 'displayOrganizationNameInHeader', 'type': 'bool'},
        'organization_logo': {'key': 'organizationLogo', 'type': 'str'},
        'automatic_logout_minutes': {'key': 'automaticLogoutMinutes', 'type': 'int'},
        'default_country': {'key': 'defaultCountry', 'type': 'str'},
        'default_meter_time_zone_id': {'key': 'defaultMeterTimeZoneId', 'type': 'int'},
        'default_date_format': {'key': 'defaultDateFormat', 'type': 'str'},
        'default_topmost_cost_center_id': {'key': 'defaultTopmostCostCenterId', 'type': 'int'},
        'default_topmost_place_id': {'key': 'defaultTopmostPlaceId', 'type': 'int'},
        'default_user_role_id': {'key': 'defaultUserRoleId', 'type': 'int'},
        'months_to_exclude_from_charts': {'key': 'monthsToExcludeFromCharts', 'type': 'int'},
    }

    def __init__(self, **kwargs):
        super(SystemSettingsRequest, self).__init__(**kwargs)
        self.organization_name = kwargs.get('organization_name', None)
        self.display_organization_name_in_header = kwargs.get('display_organization_name_in_header', None)
        self.organization_logo = kwargs.get('organization_logo', None)
        self.automatic_logout_minutes = kwargs.get('automatic_logout_minutes', None)
        self.default_country = kwargs.get('default_country', None)
        self.default_meter_time_zone_id = kwargs.get('default_meter_time_zone_id', None)
        self.default_date_format = kwargs.get('default_date_format', None)
        self.default_topmost_cost_center_id = kwargs.get('default_topmost_cost_center_id', None)
        self.default_topmost_place_id = kwargs.get('default_topmost_place_id', None)
        self.default_user_role_id = kwargs.get('default_user_role_id', None)
        self.months_to_exclude_from_charts = kwargs.get('months_to_exclude_from_charts', None)
