# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class UDFEdit(Model):
    """UDFEdit.

    All required parameters must be populated in order to send to Azure.

    :param name: Required. The UDF's name <span
     class='property-internal'>Required</span> <span
     class='property-internal'>Must be between 0 and 32 characters</span>
    :type name: str
    :param description: The description for the UDF.
     Not required, if left blank the description will not be updated. <span
     class='property-internal'>Must be between 0 and 128 characters</span>.
     Default value: "Æ" .
    :type description: str
    :param display_order: Required. <p>The UDF's display order</p>
     <p>A value of 1 or less will put this record the beginning of the list</p>
     <p>A value greater than the stored max will put this record at the end of
     the list</p>
     <p>When the old display order of the UDF being updated is less than the
     new specified display order, decrement the display order of all other UDFs
     falling between the old and new display order</p>
     <p>When the old display order of the UDF being updated is greater than the
     new specified display order, increment the display order of all other UDFs
     falling between the old and new display order</p>
     <p>All UDF lying outside the range of display orders being updated retain
     their original values</p> <span class='property-internal'>Required</span>
    :type display_order: int
    :param udf_select_values: <p>An array of options to populate a UDF select
     list.</p>
     <p>Required when the UDF being edited has a dataTypeId of 12 otherwise
     this will be ignored.</p>
     <p>To remove an option from the select list, omit it from this array.
     Options that are in use may not be deleted. To add a new option, pass in
     null as the udfSelectValueId</p>
    :type udf_select_values: list[~energycap.sdk.models.UDFSelectValueEdit]
    :param important: Important flag for the UDF. UDFs marked as important
     will be highlighted during data entry.
     Not required, if left blank the flag's value will not be changed.
    :type important: bool
    """

    _validation = {
        'name': {'required': True, 'max_length': 32, 'min_length': 0},
        'description': {'max_length': 128, 'min_length': 0},
        'display_order': {'required': True},
    }

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'display_order': {'key': 'displayOrder', 'type': 'int'},
        'udf_select_values': {'key': 'udfSelectValues', 'type': '[UDFSelectValueEdit]'},
        'important': {'key': 'important', 'type': 'bool'},
    }

    def __init__(self, *, name: str, display_order: int, description: str="Æ", udf_select_values=None, important: bool=None, **kwargs) -> None:
        super(UDFEdit, self).__init__(**kwargs)
        self.name = name
        self.description = description
        self.display_order = display_order
        self.udf_select_values = udf_select_values
        self.important = important
